# Generated by Django 5.0 on 2024-01-06 12:49

import datetime
import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('stela_control', '0037_resource_type_alter_billingrecipt_option_and_more'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.AddField(
            model_name='bankstatement',
            name='bank',
            field=models.CharField(default='no bank', max_length=255),
            preserve_default=False,
        ),
        migrations.AddField(
            model_name='bankstatement',
            name='bank_holder',
            field=models.CharField(default='no holder', max_length=255),
            preserve_default=False,
        ),
        migrations.AlterField(
            model_name='billingrecipt',
            name='option',
            field=models.CharField(choices=[('Billing receipt', 'Billing receipt'), ('Others', 'Others'), ('Monthly charge', 'Monthly charge'), ('budget', 'Budget')], max_length=60, null=True),
        ),
        migrations.AlterField(
            model_name='company',
            name='business',
            field=models.CharField(blank=True, choices=[('Media Creators', 'Media Creators'), ('Health and Wellness', 'Health and Wellness'), ('Restaurants and Food Services', 'Restaurants and Food Services'), ('Logistics and Transportation Services', 'Logistics and Transportation Services'), ('Marketing and Advertising Services', 'Marketing and Advertising Services'), ('E-commerce', 'E-commerce'), ('Beauty and Personal Care Services', 'Beauty and Personal Care Services'), ('Education and Training', 'Education and Training'), ('Consulting', 'Consulting'), ('IT Development Services', 'IT Development Services'), ('Repair and Maintenance Services', 'Repair and Maintenance Services')], max_length=100, null=True, verbose_name='Business Type'),
        ),
        migrations.AlterField(
            model_name='content',
            name='card',
            field=models.CharField(blank=True, choices=[('card-light-blue', 'card-light-blue'), ('card-light-danger', 'card-light-danger'), ('card-tale', 'card-tale'), ('card-dark-blue', 'card-dark-blue')], max_length=50, null=True, verbose_name='Color Card'),
        ),
        migrations.AlterField(
            model_name='content',
            name='category',
            field=models.CharField(blank=True, choices=[('News', 'News'), ('Honors', 'Honors'), ('Events and Conferences', 'Events and Conferences'), ('Stories', 'Stories')], default='News', max_length=100),
        ),
        migrations.AlterField(
            model_name='facebookpagecomments',
            name='update_rate',
            field=models.DateTimeField(default=datetime.datetime(2024, 1, 6, 9, 49, 8, 631227)),
        ),
        migrations.AlterField(
            model_name='itemdiscount',
            name='field',
            field=models.CharField(choices=[('Initial Payment', 'Initial Payment'), ('No Selected', 'No Selected'), ('Stela Payment Free Suscription', 'Stela Payment Free Suscription'), ('Promotional Discount', 'Promotional Discount')], max_length=60),
        ),
        migrations.AlterField(
            model_name='newsletter',
            name='template',
            field=models.CharField(choices=[('Style Template 4', 'Style Template 4'), ('Style Template 2', 'Style Template 2'), ('Style Template 1', 'Style Template 1'), ('Style Template 3', 'Style Template 3')], max_length=60, null=True, verbose_name='Style'),
        ),
        migrations.AlterField(
            model_name='order',
            name='section',
            field=models.CharField(choices=[('No Selected', 'No Selected'), ('Cloud Elastic Instance', 'Cloud Elastic Instance'), ('Stela Design', 'Stela Design'), ('Stela Marketing', 'Stela Marketing'), ('Cloud Domains', 'Cloud Domains'), ('Store', 'Store'), ('Stela Websites', 'Stela Websites')], default='No Selected', max_length=50),
        ),
        migrations.AlterField(
            model_name='pathcontrol',
            name='step',
            field=models.CharField(choices=[('Step 4', 'Step 4'), ('Step 2', 'Step 2'), ('Step 3', 'Step 3')], default='No Selected', max_length=50),
        ),
        migrations.AlterField(
            model_name='sitepolicy',
            name='section',
            field=models.CharField(blank=True, choices=[('Terms and Conditions', 'Terms and Conditions'), ('billing_terms', 'Monthly Billing Terms'), ('Disclaimer', 'Disclaimer'), ('Cookie Policy', 'Cookie Policy'), ('monthly_terms', 'Billing Terms'), ('budget_development_terms', 'Budget Development Terms'), ('budget_marketing_terms', 'Budget Marketing Terms'), ('Privacy Policy', 'Privacy Policy'), ('budget_design_terms', 'Budget Design Terms'), ('Return Policy', 'Return Policy')], default='Terms and Conditions', max_length=150),
        ),
        migrations.AlterField(
            model_name='sociallinks',
            name='social',
            field=models.CharField(choices=[('Facebook', 'Facebook'), ('Instagram', 'Instagram'), ('Linkedin', 'Linkedin'), ('Youtube', 'Youtube'), ('Github', 'Github'), ('Wikipedia', 'Wikipedia'), ('X', 'X'), ('Tiktok', 'Tiktok')], default='No Selected', max_length=50),
        ),
        migrations.AlterField(
            model_name='support',
            name='option',
            field=models.CharField(choices=[('Payments Issue', 'Payments Issue'), ('Others', 'Others'), ('I have a problem with my project', 'I have a problem with my project'), ('I have a problem with my subscription', 'I have a problem with my subscription'), ('My account has an error', 'My account has an error'), ('My delivery has been delayed', 'My delivery has been delayed')], max_length=60, verbose_name='Case'),
        ),
        migrations.AlterField(
            model_name='wallet',
            name='type',
            field=models.CharField(choices=[('Binance', 'Binance'), ('Paypal', 'Paypal'), ('Zelle', 'Zelle')], max_length=100, verbose_name='Type of Wallet'),
        ),
        migrations.CreateModel(
            name='TaxReturn',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('status', models.CharField(choices=[('draft', 'Draft'), ('publish', 'Publish')], default='Pending', max_length=10)),
                ('business', models.CharField(max_length=255)),
                ('period_date', models.DateField()),
                ('pdf_file', models.FileField(upload_to='tax_returns/')),
                ('created', models.DateTimeField(auto_now_add=True)),
                ('owner', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='tax_returns', to=settings.AUTH_USER_MODEL)),
            ],
        ),
    ]
